package com.its.op.service.its.scrs;

import com.its.op.dao.repository.its.scrs.TbScTrfcCndtMngmRepository;
import com.its.op.dto.its.scrs.TbScTrfcCndtMngmDto;
import com.its.op.entity.its.scrs.TbScTrfcCndtMngm;
import com.its.op.entity.its.scrs.TbScTrfcCndtMngmKey;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbScTrfcCndtMngmService {

    private final TbScTrfcCndtMngmRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbScTrfcCndtMngm requireOne(TbScTrfcCndtMngmKey ixrId) throws NoSuchElementException {
        Optional<TbScTrfcCndtMngm> info = this.repo.findById(ixrId);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + ixrId);
        }
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbScTrfcCndtMngmDto> findAll() {
        List<TbScTrfcCndtMngmDto> result = new ArrayList<>();
        List<TbScTrfcCndtMngm> data = this.repo.findAll();
        for (TbScTrfcCndtMngm entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbScTrfcCndtMngmDto> findAllList() {
        List<TbScTrfcCndtMngmDto> result = new ArrayList<>();
        List<TbScTrfcCndtMngm> data = this.repo.findAllList();
        for (TbScTrfcCndtMngm entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbScTrfcCndtMngmDto findById(TbScTrfcCndtMngmKey ixrId) {
        TbScTrfcCndtMngm entity = requireOne(ixrId);
        return entity.toDto();
    }

    @Transactional(readOnly = true)
    public List<TbScTrfcCndtMngmDto> findListById(String ixrId) {
        List<TbScTrfcCndtMngm> data = this.repo.findListById(ixrId);
        List<TbScTrfcCndtMngmDto> result = new ArrayList<>();
        for (TbScTrfcCndtMngm entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 변경
    @Transactional
    public TbScTrfcCndtMngmDto updateById(TbScTrfcCndtMngmKey ixrId, TbScTrfcCndtMngmDto.TbScTrfcCndtMngmUpdReq req) {
        TbScTrfcCndtMngm entity = requireOne(ixrId);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbScTrfcCndtMngmDto> mergeInfoList(List<TbScTrfcCndtMngmDto.TbScTrfcCndtMngmUpdReq> reqList) {
        List<TbScTrfcCndtMngmDto> result = new ArrayList<>();
        for (TbScTrfcCndtMngmDto.TbScTrfcCndtMngmUpdReq req : reqList) {
            TbScTrfcCndtMngm obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbScTrfcCndtMngmDto mergeInfo(TbScTrfcCndtMngmDto.TbScTrfcCndtMngmUpdReq req) {
        TbScTrfcCndtMngm obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbScTrfcCndtMngmDto deleteById(TbScTrfcCndtMngmKey ixrId) {
        TbScTrfcCndtMngm entity = requireOne(ixrId);
        this.repo.deleteById(ixrId);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbScTrfcCndtMngmDto> deleteByIds(List<TbScTrfcCndtMngmKey> ids) {
        List<TbScTrfcCndtMngmDto> result = new ArrayList<>();
        for (TbScTrfcCndtMngmKey id : ids) {
            Optional<TbScTrfcCndtMngm> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

}
